      *****************************************************************
      *  MICRO FOCUS CICS DEMONSTRATION APPLICATION                   *
      *****************************************************************
       IDENTIFICATION DIVISION.
       PROGRAM-ID.  IT2INQ.

      *****************************************************************
       ENVIRONMENT DIVISION.

      *****************************************************************
       DATA DIVISION.
       WORKING-STORAGE SECTION.

       01  EOJ-MESSAGE          pic X(50)
           value '     - Enter Tran ID . . .        completed IT2INQ'.

       01  LGTH                 pic S9(4)   comp.
       01  WORK-RESP-CODE       pic 9(08)   comp.
       01  XCTL-RESP-CODE       pic 9(08)   comp.
       01  ITEM-KEY             pic X(12).
       01  MSG-LINES.
           03  MSG-DATA         pic X(38).
           03  filler           pic X(38)      value LOW-VALUES.

       01  PROGRAM-NAME         pic x(8)       value SPACES.

       01  WS-RESPONSE         pic S9(8) comp.
       01  WS-REASON-CODE      pic S9(8) comp.

       01  LOCAL-TRAN-ID        pic X(4)       value 'ITI1'.

       01  SYS-ID               pic X(4).

       01  WORK-DATE.
           05  WORK-DATE-CC     pic X(02).
           05  WORK-DATE-YY     pic 9(02).
           05  WORK-DATE-MM     pic X(02).
           05  WORK-DATE-DD     pic 9(02).
       01  WORK-TIME.
           05  WORK-TIME-HH     pic X(02).
           05  WORK-TIME-NN     pic X(02).
           05  WORK-TIME-SS     pic X(02).
           05  WORK-TIME-TT     pic X(02).

       01  Z-WORK-12            pic X(12)      value SPACES.
       01  IX-12                pic 9(3)       value 0.

       01  WORK-14-2-GROUP.
           05  WORK-14-2-VALUE  pic S9(14)V9(2) value 0.

       01  WORK-7-0-GROUP.
           05  WORK-7-0-VALUE   pic 9(7)        value 0.

       01  WORK-QTY-AVAILABLE   pic 9(7)        value 0.

       01  WORK-18              pic X(18)      value SPACES.
       01  W18-1                pic 9(3)       value 0.
       01  W18-2                pic 9(3)       value 0.
       01  SIG-DIG              pic X          value 'N'.
       01  DECIMAL-BYTE         pic X          value '.'.

       COPY IT2INQ1.
       COPY DFHBMSCA.
       COPY DFHAID.

       COPY ITEMCB01.

      *****************************************************************
       LINKAGE SECTION.
       01  DFHCOMMAREA.
           03  LS-ITEMNO         pic X(12).
           03  filler            pic X(200).

      *****************************************************************
       PROCEDURE DIVISION.
       FIRST-ROUTINE.

           EXEC CICS HANDLE CONDITION
                ERROR   (GEN-ERR)
                MAPFAIL (NO-MAP)
                NOTFND  (NO-REC)
                END-EXEC.

           EXEC CICS ASSIGN
                SYSID(SYS-ID)
                END-EXEC.

      *---------------------------------------------------------------*
      *    If Program Function Key 3 then End-Of-Job.
           if  EIBAID equal DFHPF3


               move 'MN1FMS  ' to PROGRAM-NAME
               perform TRANSFER-CONTROL
      *    Should never get to here


               EXEC CICS SEND
                    FROM   (EOJ-MESSAGE)
                    LENGTH (50)
                    ERASE
                    END-EXEC

               EXEC CICS SEND
                    CONTROL FREEKB
                    END-EXEC

               EXEC CICS RETURN
                    END-EXEC
           end-if.

      *---------------------------------------------------------------*
      *    If Program Function Key 12 then End-Of-Transaction.
           if  EIBAID equal DFHPF12
               EXEC CICS SEND
                    FROM   (EOJ-MESSAGE)
                    LENGTH (50)
                    ERASE
                    END-EXEC

               EXEC CICS SEND
                    CONTROL FREEKB
                    END-EXEC

               EXEC CICS RETURN
                    END-EXEC
           end-if.

      *---------------------------------------------------------------*
      *    If COMMAREA length of zero, do first time processing. In
      *    order to have a COMMAREA next time, we must create one now.
           if  EIBCALEN = ZERO
               perform BMS-HDR-1
               move
                'Please enter a 12 digit customer number and hit ENTER'
                 to SYSMSG1I
               perform SET-PROTECT-ATTRIBUTES
               EXEC CICS SEND
                    MAP    ('IT2INQ1')
                    MAPSET ('IT2INQ1')
                    FROM   (IT2INQ1I)
                    ERASE
                    END-EXEC
               move LOW-VALUES to IT2INQ1O
               EXEC CICS RETURN
                    TRANSID (LOCAL-TRAN-ID)
                    COMMAREA (IT2INQ1O)
                    LENGTH    (32)
                    END-EXEC
           end-if.
      *---------------------------------------------------------------*
      *    Test for the ENTER KEY
      *
           if  EIBAID is not equal to DFHENTER
               perform BMS-HDR-1
               move
              'I repeat enter a 12 digit item number and hit ENTER'
                        to SYSMSG1I
               perform SET-PROTECT-ATTRIBUTES
               EXEC CICS SEND
                    MAP    ('IT2INQ1')
                    MAPSET ('IT2INQ1')
                    ERASE
                    END-EXEC
               move LOW-VALUES to IT2INQ1O
               EXEC CICS RETURN
                    TRANSID (LOCAL-TRAN-ID)
                    COMMAREA (IT2INQ1O)
                    LENGTH    (32)
                    END-EXEC
           end-if.

      *---------------------------------------------------------------*
      *    Get data from Screen
      *
           EXEC CICS RECEIVE
                MAP    ('IT2INQ1')
                MAPSET ('IT2INQ1')
                RESP(WS-RESPONSE)
                RESP2(WS-REASON-CODE)
                END-EXEC.

           if  REQNUMBL > ZERO
               move REQNUMBI to Z-WORK-12
               perform Z-RIGHT-ADJUST-Z-WORK-12
               move Z-WORK-12 to REQNUMBI
               move REQNUMBI to LS-ITEMNO
           else
               move 'Please enter a 12 digit item number'
                 to MSG-LINES
               go to ERR-RTN
           end-if.

      *---------------------------------------------------------------*
      * Randomly read the VSAM Keyed-Sequential-Data-Set (KSDS).
      *
       READ-CUST.
           move LS-ITEMNO to ITEM-KEY.
           move 512       to LGTH.
           EXEC CICS read
                DATASET   ('ITEMMAST')
                INTO      (ITEM-RECORD)
                LENGTH    (LGTH)
                RIDFLD    (ITEM-KEY)
                KEYLENGTH (12)
                RESP      (WORK-RESP-CODE)
                END-EXEC.

      *---------------------------------------------------------------*
      *    If the read worked the data is moved to the screen
      *
           if  WORK-RESP-CODE = ZEROS
               move ITEM-NUMBER          to REQNUMBO
               move ITEM-NUMBER          to ITNUMBI
               move ITEM-DESCRIPTION     to ITDESCO
               move ITEM-UNIT-OF-MEASURE to ITUNITO
               add  ITEM-PRICE to ZERO giving WORK-14-2-VALUE
               perform SHIFT-LEFT-14-2
               move WORK-18      to ITPRCEO
               add  ITEM-COST  to ZERO giving WORK-14-2-VALUE
               perform SHIFT-LEFT-14-2
               move WORK-18              to ITCOSTO

               add  ITEM-QTY-ONHAND  to ZERO giving WORK-7-0-VALUE
               perform SHIFT-LEFT-7-0
               move WORK-18              to ITOHNDO

               add  ITEM-QTY-ALLOCATED  to ZERO giving WORK-7-0-VALUE
               perform SHIFT-LEFT-7-0
               move WORK-18              to ITALOCO

               if  ITEM-QTY-ONHAND > ITEM-QTY-ALLOCATED
                   compute WORK-QTY-AVAILABLE =
                           ITEM-QTY-ONHAND - ITEM-QTY-ALLOCATED
               else
                   move ZERO to WORK-QTY-AVAILABLE
               end-if
               add  WORK-QTY-AVAILABLE  to ZERO giving WORK-7-0-VALUE
               perform SHIFT-LEFT-7-0
               move WORK-18              to ITAVAIO

               move ITEM-LADATE          to ITLDATEO
               move ITEM-LATIME          to ITLTIMEO
               move ITEM-TOKEN           to ITTOKENO
               move LOW-VALUES           to SYSMSG1O
           else
               move SPACES               to REQNUMBO
                                            ITDESCO
                                            ITUNITO
                                            ITPRCEO
                                            ITCOSTO
                                            ITOHNDO
                                            ITALOCO
                                            ITAVAIO
                                            ITLDATEO
                                            ITLTIMEO
                                            ITTOKENO
                                            SYSMSG1O
                move LS-ITEMNO to MSG-LINES
                move '* Item number not found,please try again...'
                  to MSG-LINES(14:44)
                go to ERR-RTN
           end-if.

      *---------------------------------------------------------------*
      *    Provide a new COMMAREA and send data to screen
      *
           perform BMS-HDR-1
           move 'Enter another item number or hit F3 to EXIT'
             to MSG-LINES
           move MSG-LINES to SYSMSG1O.
           move -1 to REQNUMBL
           perform SET-PROTECT-ATTRIBUTES

           EXEC CICS SEND
                MAP ('IT2INQ1')
                MAPSET ('IT2INQ1')
                DATAONLY ERASEAUP
                END-EXEC.
           EXEC CICS RETURN
                TRANSID (LOCAL-TRAN-ID)
                COMMAREA (DFHCOMMAREA)
                LENGTH   (212)
                END-EXEC.

      *****************************************************************
       SHIFT-LEFT-7-0.
           move SPACES to WORK-18
           move 'N' to SIG-DIG
           add 1 to ZERO giving W18-1
           add 1 to ZERO giving W18-2
           perform 7 times
             if  WORK-7-0-GROUP(W18-1:1) not = ZERO
                 move 'Y' to SIG-DIG
             end-if
             if  W18-1 = 7
                 move 'Y' to SIG-DIG
             end-if
             if  SIG-DIG = 'Y'
                 move WORK-7-0-GROUP(W18-1:1) to WORK-18(W18-2:1)
                 add 1 to W18-2
             end-if
             add 1 to W18-1
           end-perform
           exit.

      *****************************************************************
       SHIFT-LEFT-14-2.
           move SPACES          to WORK-18
           move 'N' to SIG-DIG
           add 1 to ZERO giving W18-1
           add 1 to ZERO giving W18-2
           perform 16 times
             if  WORK-14-2-GROUP(W18-1:1) not = ZERO
                 move 'Y' to SIG-DIG
             end-if
             if  W18-1 = 15
                 move 'Y' to SIG-DIG
                 move DECIMAL-BYTE to WORK-18(W18-2:1)
                 add 1 to W18-2
             end-if
             if  SIG-DIG = 'Y'
                 move WORK-14-2-GROUP(W18-1:1) to WORK-18(W18-2:1)
                 add 1 to W18-2
             end-if
             add 1 to W18-1
           end-perform
           exit.

      *****************************************************************
       SET-PROTECT-ATTRIBUTES.
           move DFHPROTI to SYSPAGEA
                            SYSDATEA
                            SYS-IDA
                            SYSTIMEA
                            ITNUMBA
                            ITDESCA
                            ITUNITA
                            ITPRCEA
                            ITCOSTA
                            ITLDATEA
                            ITLTIMEA
                            ITTOKENA
                            SYSMSG1A
           exit.

      *****************************************************************
       BMS-HDR-1.
           move 'IT2INQ1 ' to SYSPAGEO
           move SYS-ID to SYS-IDO.
           perform Z-GET-DATE-AND-TIME
           exit.

      *****************************************************************
      * Exception routines
      *****************************************************************
       GEN-ERR.
           move 'Someone GOOFED, should not be here!' to MSG-LINES.
           move -1 to REQNUMBL.
           go to ERR-RTN.

      *---------------------------------------------------------------*
       NO-MAP.
           move 'Please enter item number' to MSG-LINES.
           go to ERR-RTN.

      *---------------------------------------------------------------*
       NO-REC.
           if EIBDS is equal to 'CUSTMAST'
              move 'Item not found' to SYSMSG1O
              move -1 to REQNUMBL
              move DFHBMBRY to REQNUMBL
           end-if.

      *---------------------------------------------------------------*
       ERR-RTN.
           perform BMS-HDR-1
           move MSG-LINES to SYSMSG1O.
      *    move DFHBMBRY  to SYSMSGA
           move -1 to REQNUMBL

           EXEC CICS SEND
                MAP    ('IT2INQ1')
                MAPSET ('IT2INQ1')
      *         DATAONLY
                CURSOR
                END-EXEC.
           EXEC CICS RETURN
                TRANSID (LOCAL-TRAN-ID)
                COMMAREA (DFHCOMMAREA)
                LENGTH   (212)
                END-EXEC.

      *****************************************************************
       TRANSFER-CONTROL.
           EXEC CICS XCTL
                PROGRAM(PROGRAM-NAME)
                RESP(XCTL-RESP-CODE)
                END-EXEC

           move 'Program not found, &&&&&&&&' to MSG-LINES.
           inspect MSG-LINES replacing first '&&&&&&&&'
                                          by PROGRAM-NAME
           move -1 to REQNUMBL.
           go to ERR-RTN.
      *    exit.

      *****************************************************************
      * Delete all characters to the right of the first space then
      * right-adjust with zero fill. This routine works with a single,
      * twelve character field and does not require a work area.
      *****************************************************************
       Z-RIGHT-ADJUST-Z-WORK-12.
           inspect Z-WORK-12
                   replacing CHARACTERS by ' ' after initial ' '
           perform until Z-WORK-12(12:1) not = SPACE
               if  Z-WORK-12(12:1) = SPACE
                   add 11 to ZERO giving IX-12
                   perform 11 times
                       move Z-WORK-12(IX-12:1) to Z-WORK-12(IX-12 + 1:1)
                       subtract 1 from IX-12
                   end-perform
                   move ZERO to Z-WORK-12(1:1)
               end-if
           end-perform
           exit.

      *****************************************************************
       Z-GET-DATE-AND-TIME.
           accept WORK-DATE from DATE YYYYMMDD
           accept WORK-TIME from TIME

           move 'ccyy/mm/dd'   to SYSDATEO
           move WORK-DATE(1:4) to SYSDATEO(1:4)
           move WORK-DATE(5:2) to SYSDATEO(6:2)
           move WORK-DATE(7:2) to SYSDATEO(9:2)

           move 'hh:mm:ss:dd'  to SYSTIMEO
           move WORK-TIME(1:2) to SYSTIMEO(1:2)
           move WORK-TIME(3:2) to SYSTIMEO(4:2)
           move WORK-TIME(5:2) to SYSTIMEO(7:2)
           move WORK-TIME(7:2) to SYSTIMEO(10:2)

           exit.

