       IDENTIFICATION DIVISION.
       PROGRAM-ID.  IT2UPD.
       AUTHOR.      SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2015 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any non-commercial purpose and without fee is hereby      *
      * granted, provided the SimoTime copyright notice appear on all *
      * copies of the software. The SimoTime name or Logo may not be  *
      * used in any advertising or publicity pertaining to the use    *
      * of the software without the written permission of SimoTime    *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
      *
      * MAINTENANCE
      * -----------
      * 1989/02/27 Simmons, Created program.
      * 1997/03/17 Simmons, Updated for SYSID.
      *
      *****************************************************************
      *
       ENVIRONMENT DIVISION.

      *****************************************************************
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       01  VERSION-NUMBER       pic X(9)   value 'V01.00.00'.
       01  PF-ROW-23.
           05  filler           pic X(3)   value SPACES.
           05  PF-ROW-23-04     pic X(8)   value SPACES.
           05  PF-ROW-23-12     pic X(8)   value SPACES.
           05  PF-ROW-23-20     pic X(8)   value 'F3=Menu '.
           05  PF-ROW-23-28     pic X(8)   value SPACES.
           05  PF-ROW-23-36     pic X(8)   value SPACES.
           05  PF-ROW-23-44     pic X(8)   value SPACES.
           05  PF-ROW-23-52     pic X(8)   value SPACES.
           05  PF-ROW-23-60     pic X(8)   value SPACES.
           05  PF-ROW-23-68     pic X(8)   value 'F12=Esc '.
           05  filler           pic X(3)   value SPACES.

       01  EOJ-MESSAGE          pic X(50)
           value '     - Enter Tran ID . . .        completed IT2UPD'.

       01  RECORD-LENGTH-512    pic S9(4)  comp    value 512.
       01  DATA-RESP-CODE       pic 9(08)  comp.
       01  XCTL-RESP-CODE       pic 9(08)  comp.
       01  NUMBER-WORK-16       pic 9(16)  value 0.

       01  X-EIB-MESSAGE.
           05  filler           pic X(8)   value 'EIBRESP='.
           05  X-EIB-RESP       pic 9(10)  value 0.
           05  filler           pic X(11)  value ', EIBRESP2='.
           05  X-EIB-RESP2      pic 9(10)  value 0.
           05  filler           pic X      value SPACE.
           05  X-EIB-USER-MSG   pic X(38)  value SPACES.

       01  ITEM-READ-KEY        pic X(12).
       01  MSG-LINE-1           pic X(78)  value LOW-VALUES.
       01  MSG-LINE-2           pic X(78)  value LOW-VALUES.

       01  SYS-ID               pic X(4).

       01  WORK-DATE.
           05  WORK-DATE-CC     pic X(02).
           05  WORK-DATE-YY     pic 9(02).
           05  WORK-DATE-MM     pic X(02).
           05  WORK-DATE-DD     pic 9(02).
       01  WORK-TIME.
           05  WORK-TIME-HH     pic X(02).
           05  WORK-TIME-NN     pic X(02).
           05  WORK-TIME-SS     pic X(02).
           05  WORK-TIME-TT     pic X(02).

       01  Z-WORK-12            pic X(12)   value SPACES.
       01  IX-12                pic 9(3)    value 0.

       01  PROGRAM-NAME         pic x(8)    value SPACES.

       01  WORK-14-2-GROUP.
           05  WORK-14-2-VALUE  pic S9(14)V9(2) value 0.

       01  WORK-7-0-GROUP.
           05  WORK-7-0-VALUE   pic 9(7)        value 0.

       01  WORK-QTY-AVAILABLE   pic 9(7)        value 0.

       01  WORK-18              pic X(18)      value SPACES.
       01  W18-1                pic 9(3)       value 0.
       01  W18-2                pic 9(3)       value 0.
       01  SIG-DIG              pic X          value 'N'.
       01  DECIMAL-BYTE         pic X          value '.'.

       01  WS-RESPONSE         pic S9(8) comp.
       01  WS-REASON-CODE      pic S9(8) comp.

       01  LOCAL-TRAN-ID        pic X(4)    value 'ITU1'.

       01  PROGRAM-FLAGS.
           05  P-FLAG-ANIM      pic X      value 'N'.
           05  P-FLAG-JOURNAL   pic X      value 'Y'.

       01  WORK-ITEMS.
           05  WS-ESD128-RIDFLD PIC S9(8)     COMP VALUE +0.
           05  WS-ESD01K-RIDFLD PIC S9(8)     COMP VALUE +0.
           05  WS-ESD350-RIDFLD PIC S9(8)     COMP VALUE +0.

       01  ESD128-RECORD.
           05  ESD128-DATA      pic X(128) value SPACES.
       01  ESD128-FILE          pic X(8)   value 'ESDSC128'.

       01  ESD01K-RECORD.
           05  ESD01K-DATA      pic X(128) value SPACES.
       01  ESD01K-FILE          pic X(8)   value 'ESDSC01K'.

       01  ESD350-RECORD.
           05  ESD350-DATA      pic X(350) value SPACES.
       01  ESD350-FILE          pic X(8)   value 'ESDSC350'.

          COPY IT2UPD1.
          COPY DFHBMSCA.
          COPY DFHAID.
      *   COPY DFHEIBLK.
          COPY ITEMCB01.

      *****************************************************************
       LINKAGE SECTION.
       01  DFHCOMMAREA.
           03  LS-ITEMNO         pic X(12).
           03  filler            pic X(4096).

      *****************************************************************
       PROCEDURE DIVISION.
      *    if  P-FLAG-ANIM = 'Y'
      *        CALL 'CBL_DEBUGBREAK'
      *    end-if.

           perform CLEAR-MESSAGES

           EXEC CICS HANDLE CONDITION
                ERROR   (GENERAL-ERROR-ROUTINE)
                MAPFAIL (MAP-FAIL-ROUTINE)
                NOTFND  (GENERAL-ERROR-ROUTINE)
                END-EXEC.

           evaluate TRUE
             when EIBCALEN = ZERO
                  perform SCREEN-IO-SEND-UPDATE
             when EIBAID   = DFHPF3
                  perform END-OF-PROGRAM-03
             when EIBAID   = DFHPF9
                  perform UPDATE-ITEM-INFORMATION
             when EIBAID   = DFHPF12
                  perform END-OF-PROGRAM-12
             when EIBAID   = DFHENTER
                  perform GET-ITEM-INFORMATION
             when other
                  move 'Type a new request and press the ENTER key'
                  to MSG-LINE-1
                  perform RECOVERY-ROUTINE
           end-evaluate.
      *    Should never get to here...
           perform END-OF-PROGRAM-12.

      *****************************************************************
       BUILD-HEADER-INFO.
           EXEC CICS ASSIGN
                SYSID(SYS-ID)
                END-EXEC.

           move 'IT2UPD1 ' to SYSPAGEO
           move SYS-ID to SYS-IDO.
           perform Z-GET-DATE-AND-TIME.
           exit.

      *****************************************************************
       CLEAR-MESSAGES.
           move SPACES to MSG-LINE-1
           move SPACES to MSG-LINE-2
           move SPACES to SYSMSG1O
           move SPACES to SYSMSG2O
           exit.

      *****************************************************************
       DATA-FILE-TO-SCREEN.
           move ITEM-NUMBER           to REQNUMBO
           move ITEM-NUMBER           to ITNUMBO
           move ITEM-DESCRIPTION      to ITDESCO
           move ITEM-UNIT-OF-MEASURE  to ITUNITO

           add  ITEM-PRICE to ZERO giving WORK-14-2-VALUE
           perform SHIFT-LEFT-14-2
           move WORK-18      to ITPRCEO
           add  ITEM-COST  to ZERO giving WORK-14-2-VALUE
           perform SHIFT-LEFT-14-2
           move WORK-18              to ITCOSTO

           add  ITEM-QTY-ONHAND  to ZERO giving WORK-7-0-VALUE
           perform SHIFT-LEFT-7-0
           move WORK-18              to ITOHNDO

           add  ITEM-QTY-ALLOCATED  to ZERO giving WORK-7-0-VALUE
           perform SHIFT-LEFT-7-0
           move WORK-18              to ITALOCO

           if  ITEM-QTY-ONHAND > ITEM-QTY-ALLOCATED
               compute WORK-QTY-AVAILABLE =
                       ITEM-QTY-ONHAND - ITEM-QTY-ALLOCATED
           else
               move ZERO to WORK-QTY-AVAILABLE
           end-if
           add  WORK-QTY-AVAILABLE  to ZERO giving WORK-7-0-VALUE
           perform SHIFT-LEFT-7-0
           move WORK-18              to ITAVAIO

           move ITEM-LADATE           to ITLDATEO
           move ITEM-LATIME           to ITLTIMEO
           if  ITEM-TOKEN is NUMERIC
               move ITEM-TOKEN        to ITTOKENO
           else
               move ITEM-TOKEN        to ITTOKENO
           exit.

      *****************************************************************
       DATA-INITIALIZE-SCREEN-RECORD.
           move SPACES to REQNUMBO
                          ITNUMBO
                          ITDESCO
                          ITUNITO
                          ITPRCEO
                          ITCOSTO
                          ITOHNDO
                          ITALOCO
                          ITAVAIO
                          ITLDATEO
                          ITLTIMEO
                          ITTOKENO
                          SYSMSG1O
                          SYSMSG2O
           exit.

      *****************************************************************
       DATA-SCREEN-TO-FILE.
      *    move REQNUMBI to CUST-NUMBER
           move ITNUMBI  to ITEM-NUMBER
           move ITDESCI  to ITEM-DESCRIPTION
           move ITUNITI  to ITEM-UNIT-OF-MEASURE
      *     move ITPRCEI  to ITEM-PRICE
      *     move ITCOSTI  to ITEM-COST
      *     move ITOHNDI  to ITEM-QTY-ONHAND
      *     move ITALOCI  to ITEM-QTY-ALLOCATED

           move SPACES  to Z-WORK-12
           move ITOHNDI to Z-WORK-12
           perform Z-RIGHT-ADJUST-Z-WORK-12
           move Z-WORK-12(6:7) to WORK-7-0-GROUP
           add WORK-7-0-VALUE to ZERO giving ITEM-QTY-ONHAND

           move SPACES  to Z-WORK-12
           move ITALOCI to Z-WORK-12
           perform Z-RIGHT-ADJUST-Z-WORK-12
           move Z-WORK-12(6:7) to WORK-7-0-GROUP
           add WORK-7-0-VALUE to ZERO giving ITEM-QTY-ALLOCATED

           if  ITEM-QTY-ONHAND > ITEM-QTY-ALLOCATED
               compute WORK-QTY-AVAILABLE =
                       ITEM-QTY-ONHAND - ITEM-QTY-ALLOCATED
           else
               move ZERO to WORK-QTY-AVAILABLE
           end-if

           move ITLDATEI to ITEM-LADATE
           move ITLTIMEI to ITEM-LATIME
           move ITTOKENI to ITEM-TOKEN
           exit.

      *****************************************************************
       EDIT-SCREEN-INFO-FOR-UPDATE.
           move SPACES  to Z-WORK-12
           move ITOHNDI to Z-WORK-12
           perform Z-RIGHT-ADJUST-Z-WORK-12
           move Z-WORK-12(6:7) to WORK-7-0-GROUP
           if  WORK-7-0-VALUE is NUMERIC
               add WORK-7-0-VALUE to ZERO giving ITEM-QTY-ONHAND
           else
               move ITEM-NUMBER        to SYSMSG1O(1:12)
               move 'ITEM-QTY-ONHAND must be a numeric value         '
                 to SYSMSG1O(14:48)
               perform SCREEN-IO-SEND-UPDATE
           end-if

           move SPACES  to Z-WORK-12
           move ITALOCI to Z-WORK-12
           perform Z-RIGHT-ADJUST-Z-WORK-12
           move Z-WORK-12(6:7) to WORK-7-0-GROUP
           if  WORK-7-0-VALUE is NUMERIC
               add WORK-7-0-VALUE to ZERO giving ITEM-QTY-ALLOCATED
           else
               move ITEM-NUMBER        to SYSMSG1O(1:12)
               move 'ITEM-QTY-ALLOCATED must be a numeric value      '
                 to SYSMSG1O(14:48)
               perform SCREEN-IO-SEND-UPDATE
           end-if

           if  ITEM-QTY-ONHAND > ITEM-QTY-ALLOCATED
               compute WORK-QTY-AVAILABLE =
                       ITEM-QTY-ONHAND - ITEM-QTY-ALLOCATED
           else
               move ZERO to WORK-QTY-AVAILABLE
           end-if
           add  WORK-QTY-AVAILABLE  to ZERO giving WORK-7-0-VALUE
           perform SHIFT-LEFT-7-0
           move WORK-18              to ITAVAIO

           exit.

      *****************************************************************
       END-OF-PROGRAM-03.
           move 'MN1FMS  ' to PROGRAM-NAME
           perform TRANSFER-CONTROL
      *    Should never get to here...
           exit.

      *****************************************************************
       END-OF-PROGRAM-12.
           EXEC CICS SEND
                FROM   (EOJ-MESSAGE)
                LENGTH (50)
                ERASE
                END-EXEC

           EXEC CICS SEND
                CONTROL FREEKB
                END-EXEC

           EXEC CICS RETURN
                END-EXEC
           exit.

      *****************************************************************
       GENERAL-ERROR-ROUTINE.
           move '                         General Error'
             to X-EIB-USER-MSG
           add EIBRESP  to ZERO giving X-EIB-RESP
           add EIBRESP2 to ZERO giving X-EIB-RESP2
           move X-EIB-MESSAGE to MSG-LINE-2.
           perform RECOVERY-ROUTINE
      *    Should never get to here...
           exit.

      *****************************************************************
       GET-ITEM-INFORMATION.
           perform SCREEN-IO-GET-DATA-FOR-INQUIRY
           perform ITEMMAST-READ

           if  DATA-RESP-CODE = ZEROS
               move 'F9=Updt ' to PF-ROW-23-44
               perform DATA-FILE-TO-SCREEN
           else
               perform DATA-INITIALIZE-SCREEN-RECORD
               perform Z-GET-DATE-AND-TIME
               move WORK-DATE   to ITEM-LADATE
               move WORK-TIME   to ITEM-LATIME
               move 999         to ITEM-TOKEN
               move LS-ITEMNO   to REQNUMBO
               move LS-ITEMNO   to ITNUMBO
               move ITEM-LADATE to ITLDATEO
               move ITEM-LATIME to ITLTIMEO
               move ITEM-TOKEN  to ITTOKENO

               move 'F9=Add  '  to PF-ROW-23-44
               move LS-ITEMNO   to MSG-LINE-1
      *        move '* ITEM number not found,please try again... '
               move '* Record not found, try again or Add New Record '
                 to MSG-LINE-1(14:48)
               perform POST-MSG-2-EIBRESP
               perform RECOVERY-ROUTINE
           end-if.

           perform SCREEN-IO-SEND-UPDATE
      *    Should never get to here...
           exit.

      *****************************************************************
       ITEMMAST-READ.
           move LS-ITEMNO to ITEM-READ-KEY    .
           EXEC CICS READ
                DATASET   ('ITEMMAST')
                INTO      (ITEM-RECORD)
                LENGTH    (RECORD-LENGTH-512)
                RIDFLD    (ITEM-READ-KEY    )
                KEYLENGTH (12)
                RESP      (DATA-RESP-CODE)
                END-EXEC.
           exit.

      *****************************************************************
       ITEMMAST-READ-UPDATE.
           EXEC CICS READ
                DATASET   ('ITEMMAST')
                INTO      (ITEM-RECORD)
                LENGTH    (RECORD-LENGTH-512)
                RIDFLD    (ITEM-READ-KEY    )
                KEYLENGTH (12)
                UPDATE
                RESP      (DATA-RESP-CODE)
                END-EXEC.
           exit.

      *****************************************************************
       ITEMMAST-REWRITE.
           EXEC CICS REWRITE
                DATASET   ('ITEMMAST')
                FROM      (ITEM-RECORD)
                LENGTH    (RECORD-LENGTH-512)
                RESP      (DATA-RESP-CODE)
                END-EXEC.
           exit.

      *****************************************************************
       ITEMMAST-WRITE.
           EXEC CICS WRITE
                DATASET   ('ITEMMAST')
                FROM      (ITEM-RECORD)
                LENGTH    (RECORD-LENGTH-512)
                RIDFLD    (ITEM-READ-KEY    )
                RESP      (DATA-RESP-CODE)
                END-EXEC.
           exit.

      *****************************************************************
       MAP-FAIL-ROUTINE.
           move '                           Map Failure'
             to X-EIB-USER-MSG
           add EIBRESP  to ZERO giving X-EIB-RESP
           add EIBRESP2 to ZERO giving X-EIB-RESP2
           move X-EIB-MESSAGE to MSG-LINE-2.
           perform RECOVERY-ROUTINE
      *    Should never get to here...
           exit.

      *****************************************************************
       POST-MSG-2-EIBRESP.
           if  X-EIB-USER-MSG = SPACES
               move '                          EIB Response'
                 to X-EIB-USER-MSG
           end-if
           add EIBRESP  to ZERO giving X-EIB-RESP
           add EIBRESP2 to ZERO giving X-EIB-RESP2
           move X-EIB-MESSAGE to MSG-LINE-2.

           exit.

      *****************************************************************
       RECOVERY-ROUTINE.
           move MSG-LINE-1 to SYSMSG1O.
           move MSG-LINE-2 to SYSMSG2O.
           move -1 to REQNUMBL
           perform SCREEN-IO-SEND-UPDATE
      *    Should never get to here...
           exit.

      *****************************************************************
       SCREEN-IO-GET-DATA-FOR-INQUIRY.
           EXEC CICS RECEIVE
                MAP    ('IT2UPD1')
                MAPSET ('IT2UPD1')
                RESP(WS-RESPONSE)
                RESP2(WS-REASON-CODE)
                END-EXEC.

      *        Field Length > zero...
           if  REQNUMBL > ZERO
               move REQNUMBI to Z-WORK-12
               perform Z-RIGHT-ADJUST-Z-WORK-12
               move Z-WORK-12 to REQNUMBI
               move REQNUMBI to LS-ITEMNO
           else
               move 'Please enter a 12 digit ITEM number...'
                 to MSG-LINE-1
               perform RECOVERY-ROUTINE
           end-if.
           exit.

      *****************************************************************
       SCREEN-IO-GET-DATA-FOR-UPDATE.
           EXEC CICS RECEIVE
                MAP    ('IT2UPD1')
                MAPSET ('IT2UPD1')
                END-EXEC.

           if  REQNUMBL > ZERO
               move REQNUMBI to Z-WORK-12
               perform Z-RIGHT-ADJUST-Z-WORK-12
               move Z-WORK-12 to REQNUMBI
               move REQNUMBI to LS-ITEMNO
           end-if.
           exit.

      *****************************************************************
       SCREEN-IO-SEND-UPDATE.
           perform BUILD-HEADER-INFO
           move PF-ROW-23 to PFROW23O
           EXEC CICS SEND
                MAP    ('IT2UPD1')
                MAPSET ('IT2UPD1')
                ERASE
                END-EXEC
           move LOW-VALUES to IT2UPD1O
           EXEC CICS RETURN
                TRANSID (LOCAL-TRAN-ID)
                COMMAREA (IT2UPD1O)
                LENGTH    (4096)
                END-EXEC

      *    Should never get to here...
           exit.

      *****************************************************************
       SHIFT-LEFT-7-0.
           move SPACES to WORK-18
           move 'N' to SIG-DIG
           add 1 to ZERO giving W18-1
           add 1 to ZERO giving W18-2
           perform 7 times
             if  WORK-7-0-GROUP(W18-1:1) not = ZERO
                 move 'Y' to SIG-DIG
             end-if
             if  W18-1 = 7
                 move 'Y' to SIG-DIG
             end-if
             if  SIG-DIG = 'Y'
                 move WORK-7-0-GROUP(W18-1:1) to WORK-18(W18-2:1)
                 add 1 to W18-2
             end-if
             add 1 to W18-1
           end-perform
           exit.

      *****************************************************************
       SHIFT-LEFT-14-2.
           move SPACES          to WORK-18
           move 'N' to SIG-DIG
           add 1 to ZERO giving W18-1
           add 1 to ZERO giving W18-2
           perform 16 times
             if  WORK-14-2-GROUP(W18-1:1) not = ZERO
                 move 'Y' to SIG-DIG
             end-if
             if  W18-1 = 15
                 move 'Y' to SIG-DIG
                 move DECIMAL-BYTE to WORK-18(W18-2:1)
                 add 1 to W18-2
             end-if
             if  SIG-DIG = 'Y'
                 move WORK-14-2-GROUP(W18-1:1) to WORK-18(W18-2:1)
                 add 1 to W18-2
             end-if
             add 1 to W18-1
           end-perform
           exit.

      *****************************************************************
       TRANSFER-CONTROL.
           EXEC CICS XCTL
                PROGRAM(PROGRAM-NAME)
                RESP(XCTL-RESP-CODE)
                END-EXEC

      *    Should never get to here...
           move 'Program not found, &&&&&&&&' to MSG-LINE-1.
           inspect MSG-LINE-1 replacing first '&&&&&&&&'
                                          by PROGRAM-NAME
           move -1 to REQNUMBL.
           perform RECOVERY-ROUTINE.
      *    exit.

      *****************************************************************
       UPDATE-ITEM-INFORMATION.
           perform SCREEN-IO-GET-DATA-FOR-UPDATE

           perform EDIT-SCREEN-INFO-FOR-UPDATE

           if  ITTOKENI = 999
               perform UPDATE-ITEM-INFORMATION-02
           else
               perform UPDATE-ITEM-INFORMATION-01
           end-if
           exit.


      *****************************************************************
       UPDATE-ITEM-INFORMATION-01.
      *    Attempt to update an existing record
           move ITNUMBI to ITEM-READ-KEY
           perform ITEMMAST-READ-UPDATE

           if  DATA-RESP-CODE not = 0
               add DATA-RESP-CODE to ZERO giving NUMBER-WORK-16
               move 'ReRead Failed,  ' to MSG-LINE-1(1:16)
               move ITNUMBI            to MSG-LINE-1(16:12)
               move ITEM-NUMBER        to MSG-LINE-1(30:12)
               move VERSION-NUMBER     to MSG-LINE-1(70:9)
               perform GENERAL-ERROR-ROUTINE
           end-if.

           perform DATA-SCREEN-TO-FILE

           perform Z-GET-DATE-AND-TIME
           move WORK-DATE to ITEM-LADATE
           move WORK-TIME to ITEM-LATIME
           move ZEROES to ITEM-TOKEN

           perform ITEMMAST-REWRITE

           if  DATA-RESP-CODE = 0
               move
               'Update Completed, type new request and press ENTER key'
               to MSG-LINE-1(1:54)
               move MSG-LINE-1 to SYSMSG1O
               move '        ' to PF-ROW-23-44
               perform SCREEN-IO-SEND-UPDATE
           else
               add DATA-RESP-CODE to ZERO giving NUMBER-WORK-16
               move 'Update Failed,  ' to MSG-LINE-1(1:16)
               move ITNUMBI            to MSG-LINE-1(16:12)
               move ITEM-NUMBER        to MSG-LINE-1(30:12)
               move VERSION-NUMBER     to MSG-LINE-1(70:9)
               perform GENERAL-ERROR-ROUTINE
           end-if.

      *    Should never get to here...
           exit.

      *****************************************************************
       UPDATE-ITEM-INFORMATION-02.
      *    Attempt to add a new record
           move ITNUMBI to ITEM-READ-KEY
           perform DATA-SCREEN-TO-FILE

           perform Z-GET-DATE-AND-TIME
           move WORK-DATE to ITEM-LADATE
           move WORK-TIME to ITEM-LATIME
           move ZEROES to ITEM-TOKEN

           perform ITEMMAST-WRITE

           if  DATA-RESP-CODE = 0
               move
               'Write Completed, type new request and press ENTER key '
               to MSG-LINE-1(1:54)
               move MSG-LINE-1 to SYSMSG1O
               move '        ' to PF-ROW-23-44
               perform SCREEN-IO-SEND-UPDATE
           else
               add DATA-RESP-CODE to ZERO giving NUMBER-WORK-16
               move 'Write Failed,   ' to MSG-LINE-1(1:16)
               move ITNUMBI            to MSG-LINE-1(16:12)
               move ITEM-NUMBER        to MSG-LINE-1(30:12)
               move VERSION-NUMBER     to MSG-LINE-1(70:9)
               perform GENERAL-ERROR-ROUTINE
           end-if.

      *    Should never get to here...
           exit.

      *****************************************************************
      * Delete all characters to the right of the first space then
      * right-adjust with zero fill. This routine works with a single,
      * twelve character field and does not require a work area.
      *****************************************************************
       Z-RIGHT-ADJUST-Z-WORK-12.
           inspect Z-WORK-12
                   replacing CHARACTERS by ' ' after initial ' '
           perform until Z-WORK-12(12:1) not = SPACE
               if  Z-WORK-12(12:1) = SPACE
                   add 11 to ZERO giving IX-12
                   perform 11 times
                     move Z-WORK-12(IX-12:1) to Z-WORK-12(IX-12 + 1:1)
                     subtract 1 from IX-12
                   end-perform
                   move ZERO to Z-WORK-12(1:1)
               end-if
           end-perform
           exit.

      *****************************************************************
       Z-GET-DATE-AND-TIME.
           accept WORK-DATE from DATE YYYYMMDD
           accept WORK-TIME from TIME

           move 'ccyy/mm/dd'   to SYSDATEO
           move WORK-DATE(1:4) to SYSDATEO(1:4)
           move WORK-DATE(5:2) to SYSDATEO(6:2)
           move WORK-DATE(7:2) to SYSDATEO(9:2)

           move 'hh:mm:ss:dd'  to SYSTIMEO
           move WORK-TIME(1:2) to SYSTIMEO(1:2)
           move WORK-TIME(3:2) to SYSTIMEO(4:2)
           move WORK-TIME(5:2) to SYSTIMEO(7:2)
           move WORK-TIME(7:2) to SYSTIMEO(10:2)

           exit.

